package com.njcn.csdevice.api.fallback;

import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.csdevice.api.CsMarketDataFeignClient;
import com.njcn.csdevice.pojo.vo.CsMarketDataVO;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author xy
 */
@Slf4j
@Component
public class CsMarketDataClientFallbackFactory implements FallbackFactory<CsMarketDataFeignClient> {
    @Override
    public CsMarketDataFeignClient create(Throwable cause) {
        //判断抛出异常是否为解码器抛出的业务异常
        Enum<?> exceptionEnum = CommonResponseEnum.SERVICE_FALLBACK;
        if (cause.getCause() instanceof BusinessException) {
            BusinessException businessException = (BusinessException) cause.getCause();
        }
        Enum<?> finalExceptionEnum = exceptionEnum;
        return new CsMarketDataFeignClient() {

            @Override
            public HttpResult<Boolean> insertData(String userId, String engineeringId) {
                log.error("{}异常，降级处理，异常为：{}","根据用户、工程新增数据异常",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }

            @Override
            public HttpResult<List<CsMarketDataVO>> queryByUseId(String userId) {
                log.error("{}异常，降级处理，异常为：{}","查询营销,工程数据异常",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }

        };
    }
}
